; File:     ComboBox.asm
; by:       Rui Loureiro
;===============================================================================================
;                   O conjunto de procedimentos seguintes usa apenas
;                        o buffer de strings RCL _BufferStrCBEX
;
;       1  - invoke    AddTblCBEX, pTbl        : coloca as strings da tabela pTbl
;                                                 no buffer _BufferStrCBEX 
;
;       2  - COMBOBOXEX2                       : Cria a ComboBox
;             call  ComboBoxExSetup             ; Insere as strings na ComboBox
;
;       3  - em CBN_SELCHANGE: 
;             invoke   CopyRegCBEX, pReg, oFld  : copia a string no index _hComboItem2
;                                                 do buffer _BufferStrCBEX para o registo
;
;       4  - em WM_NOTIFY:     
;             call    MoveStrCBEX               : insere a string em EBX no buffer
;                                                 _BufferStrCBEX
;
;           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Se usamos       invoke  AddTblCBEX, pTbl
;           usar  call    ComboBoxExSetup
;
;
ComboBoxExSetup proc  
                
                invoke  ComboEXSetup, _hComboBox2, addr _BufferStrCBEX                
;---
                invoke SendMessage, _hComboBox2, CB_SETCURSEL, 0 ,0                
                mov    _ComboItem2, 0
                
                ret
ComboBoxExSetup endp
;
; Input:
;           hWnd    - ComboBox handle
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ComboEXSetup    proc    hWnd:DWORD, pTbl:DWORD
                push    esi

                mov     esi, [esp +12]                                  ; pTbl                
                xor     ebx, ebx
                jz      short _start
                
@@:             mov     _cbex._mask, CBEIF_TEXT
                mov     _cbex.iItem, -1

                mov     eax, ebx
                mul     dword ptr [esi - 12]                      
                add     eax, esi
                add     eax, 4
                mov     _cbex.pszText, eax                

                mov     _cbex.cchTextMax, 20     
                mov     _cbex.iImage,0
                mov     _cbex.iSelectedImage,0
                mov     _cbex.iOverlay,0
                mov     _cbex.iIndent,0
                mov     _cbex.lParam,0
                
                mov     eax, [esp + 8]                                  ; hWnd
                invoke  SendMessage, eax, CBEM_INSERTITEM, 0, addr _cbex
                
                add     ebx, 1
_start:         cmp     ebx, dword ptr [esi - 4]
                jne     short @B

                pop     esi
                ret     8
ComboEXSetup    endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;+++++++++++++++++++++++++++++++++++++++++++++++++++++
; EBX       - aponta string
;
; Output:
;           clc:    moveu para o buffer
;
;           stc:    comprimento 0 ou s espaos
;
MoveStrCBEX     proc
                push    ebx
                push    esi
                ;
                ; Determina o comprimento e limpa espaos  direita
                ; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                invoke  ClnRgtDos, ebx, MAXSTRLENCBEX           ;20          
                jz      _exit

                mov     esi, offset _BufferStrCBEX
                mov     eax, dword ptr [esi - 4]
                add     eax, 1
                cmp     eax, dword ptr [esi - 8]
                ja      _exit                       ; no cabe na tabela de ponteiros

                mov     dword ptr [esi - 4], eax
                ;
                sub     eax, 1
                mul     dword ptr [esi - 12] 
                add     esi, eax
                add     esi, 4
                ;
                mov     dword ptr [esi - 4], ecx
                mov     byte ptr [esi + ecx], 0
                ;
                ; Copia
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx]
                mov     byte ptr [esi + ecx], al
                jnz     short @B

                clc
                pop     esi
                pop     ebx
                ret
                
_exit:          stc
                pop     esi
                pop     ebx
                ret
MoveStrCBEX     endp
;
;
; Output:
;           clc:    moveu para o buffer
;
;           stc:    no cabe na tabela
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
MovRclCBEX      proc    pRcl:DWORD
                push    ebx
                push    esi

                mov     ebx, [esp + 12]
                mov     ecx, dword ptr [ebx - 4]
                ;
                mov     esi, offset _BufferStrCBEX
                mov     eax, dword ptr [esi - 4]
                add     eax, 1
                cmp     eax, dword ptr [esi - 8]
                ja      _exit                       ; no cabe na tabela de ponteiros

                mov     dword ptr [esi - 4], eax
                ;
                sub     eax, 1
                mul     dword ptr [esi - 12]     
                add     eax, esi
                mov     esi, eax
                add     esi, 4
                ;
                mov     dword ptr [esi - 4], ecx
                mov     byte ptr [esi + ecx], 0
                ;
                ; Copia
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx]
                mov     byte ptr [esi + ecx], al
                jnz     short @B

                clc
                pop     esi
                pop     ebx
                ret     4
                
_exit:          stc
                pop     esi
                pop     ebx
                ret     4                
MovRclCBEX      endp
;----------------------------------------------------
AddTblCBEX      proc    pTbl:DWORD
                push    esi
                
                mov     esi, [esp + 8]          ;pTbl
                xor     ebx, ebx
                ;
@@:             invoke  MovRclCBEX, [esi + ebx*4]                 
                add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]            
                jne     short @B

                pop     esi
                ret     4
AddTblCBEX      endp
;
LookRegCBEX     proc    pReg:DWORD, oFld:DWORD

                mov     eax, [esp + 4]
                add     eax, [esp + 8]
                invoke  LookRclCBEX, eax  

                ret     8
LookRegCBEX     endp
; 
; Procura no buffer pela string pRcl e define o index
; _ComboItem2 e selecciona na ComboBox
;
LookRclCBEX     proc    pRcl:DWORD
                push    esi

                mov     esi, offset _BufferStrCBEX
                xor     eax, eax
                jz      short _start

_next:          mov     _ComboItem2, eax

                mul     dword ptr [esi - 12]
                add     eax, esi
                add     eax, 4
                
                ;invoke  ChrChrCmp, eax, [esp + 8]
                jne     short @F

                invoke  SendMessage, _hComboBox2, CB_SETCURSEL, _ComboItem2, 0                
                jmp     _exit

@@:             mov     eax, _ComboItem2
                add     eax, 1
                
_start:         cmp     eax, dword ptr [esi - 4]
                jb      short _next

                mov     _ComboItem2, 0

_exit:          pop     esi
                ret     4
LookRclCBEX     endp
;
; Copia a string no index _hComboItem2 do buffer
; para o campo oFld do registo Reg
;
CopyRegCBEX     proc    pReg:DWORD, oFld:DWORD

                mov     eax, [esp + 4]
                add     eax, [esp + 8]
                invoke  CopyRclCBEX, eax  

                ret     8
CopyRegCBEX     endp
; 
; Copia a string no index _ComboItem2 do buffer
; para a string Rcl
;
CopyRclCBEX     proc    pRcl:DWORD
                push    esi
                push    edi

                mov     edi, [esp + 12]             ; pRcl
                mov     esi, offset _BufferStrCBEX               
                mov     eax, _ComboItem2

                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                je      short _no
                
                sub     ecx, 1
                cmp     eax, ecx
                jbe     short @F
                ;
                ; No est no buffer
                ; 
_no:            mov     dword ptr [edi - 4], 0
                mov     byte ptr [edi], 0
                jmp     _exit
                
@@:             mul     dword ptr [esi - 12]
                add     esi, eax
                add     esi, 4
                ;  
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, dword ptr [edi - 8]
                jbe     short @F
                ;
                mov     ecx, dword ptr [edi - 8]
                ;
@@:             mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edi + ecx], 0
                ;
                ; Copia
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                mov     byte ptr [edi + ecx], al
                jnz     short @B

_exit:          pop     edi
                pop     esi
                ret     4
CopyRclCBEX     endp
;----------------------------------------------------
; Aco:
;		Determina o comprimento e 
;           Limpa espaos  direita
;
; Output:
;           ECX         - comprimento da string
;           Flag ZERO   - 
;
ClnRgtDos		proc    pStr:DWORD, mLen:DWORD
                  push    esi
			;
                  mov     esi, [esp + 8]            ; pStr
                  mov     edx, [esp + 12]           ; mLen
                  xor     ecx, ecx
                
@@:               cmp     byte ptr [esi + ecx], 0
                  je      short _next
                  ;
                  add     ecx, 1
                  cmp     ecx, edx                  ; CBEXMAXSTRLEN
                  jb      short @B
                  ;                
                  mov     byte ptr [esi + ecx], 0   ; termina a string

_next:            or      ecx, ecx
			jz	  short _end
			;
                  ; aponta para o fim da string
                  ; ---------------------------
@@:	            cmp     byte ptr [esi + ecx - 1], 20h
			jne	  short @F
			;
                  sub     ecx, 1
			jnz	  short @B
			;
                  ; Termina a string para limpar os espaos
                  ; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
@@:               mov     byte ptr [esi + ecx], 0
			;
_exit:            or      ecx, ecx
_end:             pop     esi
                  ret     8
ClnRgtDos		endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; ###################################################
